jQuery(document).ready(function($)
{
	var DEFAULT_SKINS_NR = 9;
	
	var cur_settings_obj;
	
	$("#tabs").tabs();
	
	$("#cov_bg_color").spectrum(
	{
  	    color: "#DDDDDD",
  	  	chooseText: "Update",
  	  	showInitial: true,
  	  	showInput: true,
  	  	allowEmpty:true,
  	  	preferredFormat: "hex6"
  	});
	
	// coverflow bg image custom uploader
	var cov_bg_custom_uploader;
    
    $("#cov_bg_image_btn").click(function(e)
    {
        e.preventDefault();
 
        //If the uploader object has already been created, reopen the dialog
        if (cov_bg_custom_uploader)
        {
        	cov_bg_custom_uploader.open();
            return;
        }
        
        //Extend the wp.media object
        cov_bg_custom_uploader = wp.media.frames.file_frame = wp.media(
        {
            title: "Choose Image",
            button:
            {
                text: "Add Image"
            },
            library:
            {
            	type: "image"
            },
            multiple: false
        });
 
        //When a file is selected, grab the URL and set it as the text field's value
        cov_bg_custom_uploader.on("select", function()
        {
            attachment = cov_bg_custom_uploader.state().get("selection").first().toJSON();
            
            $("#cov_bg_image_url").val(attachment.url);
            $("#cov_bg_upload_img").attr("src", attachment.url);
        });
 
        //Open the uploader dialog
        cov_bg_custom_uploader.open();
    });

  

    $("#thumb_bg_color, #preloaderBackgroundColor, #preloaderFillColor, #slideshowPreloaderBackgroundColor, #slideshowpreloaderFillColor, #thumb_border_color1, #thumb_border_color2, #thumb_gradient_color1, #thumb_gradient_color2, #scrollbar_text_normal_color, #scrollbar_text_selected_color, #category_normal_color, #category_selected_color, #lightbox_bg_color, #lightbox_info_bg_color, #lightbox_item_border_color1, #lightbox_item_border_color2,#lightbox_item_bg_color, #bullets_normal_color, #bullets_selected_color, #light_box_background_color, #combo_box_shadow_color, #video_poster_background_color, #video_controller_background_color, #audio_controller_background_color, #time_color, #item_background_color, #descriptionGradientWindowBackgroundColor1, #descriptionGradientWindowBackgroundColor2").spectrum(
	  {
  	    color: "#666666",
  	  	chooseText: "Update",
  	  	showInitial: true,
  	  	showInput: true,
  	  	allowEmpty:true,
  	  	preferredFormat: "hex6"
  	});


    $("#tabs img").fwdTooltip({
    });

    function setSettings() {
    	var settings_obj = settingsAr[cur_order_id];
    	
    	// main settings
    	$("#name").val(settings_obj.name);
    	$("#display_type").val(settings_obj.display_type);
    	$("#cov_width").val(settings_obj.cov_width);
    	$("#coverflowOffsetHeight").val(settings_obj.coverflowOffsetHeight);
    	$("#skin_path").val(settings_obj.skin_path);
    	$("#cov_bg_color").spectrum("set", settings_obj.cov_bg_color != "transparent" ? settings_obj.cov_bg_color : null);
    	$("#cov_bg_image_url").val(settings_obj.cov_bg_image_url);
    	$("#cov_bg_upload_img").attr("src", settings_obj.cov_bg_image_url);
    	$("#bg_repeat").val(settings_obj.bg_repeat);
      $("#backgroundSize").val(settings_obj.backgroundSize);
      $("#backgroundPosition").val(settings_obj.backgroundPosition);
      
    	$("#cov_start_pos").val(settings_obj.cov_start_pos);
    	$("#cov_topology").val(settings_obj.cov_topology);
    	$("#cov_x_rot").val(settings_obj.cov_x_rot);
    	$("#cov_y_rot").val(settings_obj.cov_y_rot);
    	$("#nr_side_thumbs").val(settings_obj.nr_side_thumbs);
    	$("#infinite_loop").val(settings_obj.infinite_loop);
    	$("#cov_autoplay").val(settings_obj.cov_autoplay);
    	$("#cov_slideshow_delay").val(settings_obj.cov_slideshow_delay);
    	$("#right_click_context_menu").val(settings_obj.right_click_context_menu);
    	$("#cov_keyboard_support").val(settings_obj.cov_keyboard_support);
    	$("#fluid_width_z_index").val(settings_obj.fluid_width_z_index);
    	
    	// thumbs settings
    	$("#thumb_x_offset_3d").val(settings_obj.thumb_x_offset_3d);
		  $("#useDefaultThumbnailsWidthAndHeight").val(settings_obj.useDefaultThumbnailsWidthAndHeight);
	   	$("#thumbnailWidth").val(settings_obj.thumbnailWidth);
		  $("#thumbnailHeight").val(settings_obj.thumbnailHeight);
      $("#thumbnailMaxHeight").val(settings_obj.thumbnailMaxHeight);
      $("#thumbnailResizeOffest").val(settings_obj.thumbnailResizeOffest);
		
    	$("#thumb_x_space_3d").val(settings_obj.thumb_x_space_3d);
    	$("#thumb_z_offset_3d").val(settings_obj.thumb_z_offset_3d);
    	$("#thumb_z_space_3d").val(settings_obj.thumb_z_space_3d);
    	$("#thumb_y_angle_3d").val(settings_obj.thumb_y_angle_3d);
    	$("#thumb_hover_offset").val(settings_obj.thumb_hover_offset);
    	$("#thumb_border_size").val(settings_obj.thumb_border_size);		
		  $("#thumbnailOffsetY").val(settings_obj.thumbnailOffsetY);		
      $("#slideshowPreloaderBackgroundColor").spectrum("set", settings_obj.slideshowPreloaderBackgroundColor != "transparent" ? settings_obj.slideshowPreloaderBackgroundColor : null);
      $("#slideshowpreloaderFillColor").spectrum("set", settings_obj.slideshowpreloaderFillColor != "transparent" ? settings_obj.slideshowpreloaderFillColor : null);
      $("#preloaderBackgroundColor").spectrum("set", settings_obj.preloaderBackgroundColor != "transparent" ? settings_obj.preloaderBackgroundColor : null);
      $("#preloaderFillColor").spectrum("set", settings_obj.preloaderFillColor != "transparent" ? settings_obj.preloaderFillColor : null);
    	$("#thumb_bg_color").spectrum("set", settings_obj.thumb_bg_color != "transparent" ? settings_obj.thumb_bg_color : null);
    	$("#thumb_border_color1").spectrum("set", settings_obj.thumb_border_color1 != "transparent" ? settings_obj.thumb_border_color1 : null);
    	$("#thumb_border_color2").spectrum("set", settings_obj.thumb_border_color2 != "transparent" ? settings_obj.thumb_border_color2 : null);
    	$("#transparent_images").val(settings_obj.transparent_images);
    	$("#thumbs_alignment").val(settings_obj.thumbs_alignment);
    	$("#max_thumbs_mobile").val(settings_obj.max_thumbs_mobile);
    	$("#show_thumbs_gradient").val(settings_obj.show_thumbs_gradient);
    	$("#thumb_gradient_color1").spectrum("set", settings_obj.thumb_gradient_color1 != "transparent" ? settings_obj.thumb_gradient_color1 : null);
    	$("#thumb_gradient_color2").spectrum("set", settings_obj.thumb_gradient_color2 != "transparent" ? settings_obj.thumb_gradient_color2 : null);
    	$("#show_thumbs_text").val(settings_obj.show_thumbs_text);
    	$("#text_offset").val(settings_obj.text_offset);
      $("#textMaxWidth").val(settings_obj.textMaxWidth);
    	$("#show_thumb_box_shadow").val(settings_obj.show_thumb_box_shadow);
    	$("#box_shadow_css").val(settings_obj.box_shadow_css);
    	$("#show_reflection").val(settings_obj.show_reflection);
    	$("#reflection_height").val(settings_obj.reflection_height);
    	$("#reflection_distance").val(settings_obj.reflection_distance);
    	$("#reflection_opacity").val(settings_obj.reflection_opacity);
		  $("#use_drag_and_swipe").val(settings_obj.use_drag_and_swipe);
		
    	
    	// controls settings
    	$("#controls_max_width").val(settings_obj.controls_max_width);
    	$("#controls_position").val(settings_obj.controls_position);
    	$("#controls_offset").val(settings_obj.controls_offset);
    	$("#show_next_and_prev_coverflow_buttons").val(settings_obj.show_next_and_prev_coverflow_buttons);
		  $("#large_next_and_prev_buttons_offest").val(settings_obj.large_next_and_prev_buttons_offest);
      $("#largeNextAndPrevButtonsMaxWidthPos").val(settings_obj.largeNextAndPrevButtonsMaxWidthPos);
      $("#nextAndPrevCoverflowButtonsOffsetX").val(settings_obj.nextAndPrevCoverflowButtonsOffsetX);
      
		  $("#bullets_normal_radius").val(settings_obj.bullets_normal_radius);
		  $("#bullets_selected_radius").val(settings_obj.bullets_selected_radius);
		  $("#space_between_bullets").val(settings_obj.space_between_bullets);
		  $("#bullets_offset").val(settings_obj.bullets_offset);
		  $("#show_large_next_and_prev_coverflow_buttons").val(settings_obj.show_large_next_and_prev_coverflow_buttons);
    	$("#disable_btns_mobile").val(settings_obj.disable_btns_mobile);
    	$("#show_slideshow_btn").val(settings_obj.show_slideshow_btn);
		  $("#show_bullets_navigation").val(settings_obj.show_bullets_navigation);
    	$("#show_scrollbar").val(settings_obj.show_scrollbar);
    	$("#scrollbar_handler_width").val(settings_obj.scrollbar_handler_width);
    	$("#disable_scrollbar_mobile").val(settings_obj.disable_scrollbar_mobile);
    	$("#enable_mouse_wheel").val(settings_obj.enable_mouse_wheel);
		  $("#scrollbar_text_normal_color").spectrum("set", settings_obj.scrollbar_text_normal_color != "transparent" ? settings_obj.scrollbar_text_normal_color : null);
		  $("#scrollbar_text_selected_color").spectrum("set", settings_obj.scrollbar_text_selected_color != "transparent" ? settings_obj.scrollbar_text_selected_color : null);
		  $("#bullets_normal_color").spectrum("set", settings_obj.bullets_normal_color != "transparent" ? settings_obj.bullets_normal_color : null);
		  $("#bullets_selected_color").spectrum("set", settings_obj.bullets_selected_color != "transparent" ? settings_obj.bullets_selected_color : null);
    	
    	// categories menu settings
    	$("#show_categories_menu").val(settings_obj.show_categories_menu);
    	$("#start_category").val(settings_obj.start_category);
    	$("#categories_menu_max_width").val(settings_obj.categories_menu_max_width);
    	$("#categories_menu_offset").val(settings_obj.categories_menu_offset);
    	$("#category_normal_color").spectrum("set", settings_obj.category_normal_color != "transparent" ? settings_obj.category_normal_color : null);
    	$("#category_selected_color").spectrum("set", settings_obj.category_selected_color != "transparent" ? settings_obj.category_selected_color : null);
    	
    	//lightbox settings
  		$("#buttons_alignment").val(settings_obj.buttons_alignment);
  		$("#item_box_shadow").val(settings_obj.item_box_shadow);
  		$("#description_window_position").val(settings_obj.description_window_position);
  		$("#description_window_animation_type").val(settings_obj.description_window_animation_type);
  		$("#slide_show_auto_play").val(settings_obj.slide_show_auto_play);
  		$("#add_keyboard_support").val(settings_obj.add_keyboard_support);
  		$("#show_close_button").val(settings_obj.show_close_button);
  		$("#show_share_button").val(settings_obj.show_share_button);
  		$("#show_zoom_button").val(settings_obj.show_zoom_button);
  		$("#show_slide_show_button").val(settings_obj.show_slide_show_button);
  		$("#show_slide_show_animation").val(settings_obj.show_slide_show_animation);
  		$("#show_next_and_prev_buttons").val(settings_obj.show_next_and_prev_buttons);
  		$("#show_next_and_prev_buttons_on_mobile").val(settings_obj.show_next_and_prev_buttons_on_mobile);
  		$("#show_description_button").val(settings_obj.show_description_button);
  		$("#show_description_by_default").val(settings_obj.show_description_by_default);
  		$("#video_show_full_screen_button").val(settings_obj.video_show_full_screen_button);
  		$("#video_auto_play").val(settings_obj.video_auto_play);
  		$("#next_video_or_audio_auto_play").val(settings_obj.next_video_or_audio_auto_play);
  		$("#video_loop").val(settings_obj.video_loop);
  		$("#audio_auto_play").val(settings_obj.audio_auto_play);
  		$("#audio_loop").val(settings_obj.audio_loop);
  		$("#background_opacity").val(settings_obj.background_opacity);
  		$("#description_window_background_opacity").val(settings_obj.description_window_background_opacity);
  		$("#buttons_hide_delay").val(settings_obj.buttons_hide_delay);
  		$("#slide_show_delay").val(settings_obj.slide_show_delay);
  		$("#default_item_width").val(settings_obj.default_item_width);
  		$("#default_item_height").val(settings_obj.default_item_height);
  		$("#item_offset_height").val(settings_obj.item_offset_height);
  		$("#space_between_buttons").val(settings_obj.space_between_buttons);
  		$("#buttons_offset_in").val(settings_obj.buttons_offset_in);
  		$("#buttons_offset_out").val(settings_obj.buttons_offset_out);
  		$("#item_border_size").val(settings_obj.item_border_size);
  		$("#item_border_radius").val(settings_obj.item_border_radius);
  		$("#light_box_background_color").spectrum("set", settings_obj.light_box_background_color != "transparent" ? settings_obj.light_box_background_color : null);
  		$("#descriptionGradientWindowBackgroundColor1").spectrum("set", settings_obj.descriptionGradientWindowBackgroundColor1 != "transparent" ? settings_obj.descriptionGradientWindowBackgroundColor1 : null);
      $("#descriptionGradientWindowBackgroundColor2").spectrum("set", settings_obj.descriptionGradientWindowBackgroundColor2 != "transparent" ? settings_obj.descriptionGradientWindowBackgroundColor2 : null);
  		$("#video_poster_background_color").spectrum("set", settings_obj.video_poster_background_color != "transparent" ? settings_obj.video_poster_background_color : null);
  		$("#video_controller_background_color").spectrum("set", settings_obj.video_controller_background_color != "transparent" ? settings_obj.video_controller_background_color : null);
  		$("#audio_controller_background_color").spectrum("set", settings_obj.audio_controller_background_color != "transparent" ? settings_obj.audio_controller_background_color : null);
  		$("#time_color").spectrum("set", settings_obj.time_color != "transparent" ? settings_obj.time_color : null);
  		$("#item_background_color").spectrum("set", settings_obj.item_background_color != "transparent" ? settings_obj.item_background_color : null);
    }


    function init(){   
    	$.each(settingsAr, function(i, el)
		{
			$("#skins").append("<option value='" + el.id + "'>" + el.name + "</option>");
		});
    	
    	$("#skins").val(sid);
    	
    	if (cur_order_id < DEFAULT_SKINS_NR)
    	{
    		$("#update_btn").hide();
            $("#del_btn").hide();
    	}
    	else
    	{
    		$("#update_btn").show();
            $("#del_btn").show();
    	}
	    
	    setSettings();
	    
	    $("#preset_id").html("ID : " + sid);
	    
	    $("#tabs").tabs("option", "active", tab_init_id);
    }
    
    init();
    
    $("#skins").change(function()
    {
    	sid = parseInt($("#skins").val());
    	
    	$.each(settingsAr, function(i, el)
		{
			if (sid == el.id)
			{
				cur_order_id = i;
			}
		});
    	
    	setSettings();
    	
    	if (cur_order_id < DEFAULT_SKINS_NR)
    	{
    		$("#update_btn").hide();
            $("#del_btn").hide();
    	}
    	else
    	{
    		$("#update_btn").show();
            $("#del_btn").show();
    	}
    	
    	allFields.removeClass("ui-state-error");
    	$("#tips").text("All form fields are required.");
    	
    	$("#preset_id").html("ID : " + sid);
    });
    
    function updateSettings(){
		
    	// main settings
    	cur_settings_obj.id = sid;
    	cur_settings_obj.name = $("#name").val().replace(/"/g, "'");
    	cur_settings_obj.display_type = $("#display_type").val();
    	cur_settings_obj.cov_width = parseInt($("#cov_width").val());
    	cur_settings_obj.coverflowOffsetHeight = parseInt($("#coverflowOffsetHeight").val());
    	cur_settings_obj.skin_path = $("#skin_path").val().replace(/"/g, "'");
    	cur_settings_obj.cov_bg_color = $("#cov_bg_color").spectrum("get") ? $("#cov_bg_color").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.cov_bg_image_url = $("#cov_bg_image_url").val().replace(/"/g, "'");
    	cur_settings_obj.bg_repeat = $("#bg_repeat").val();
      cur_settings_obj.backgroundSize = $("#backgroundSize").val();
      cur_settings_obj.backgroundPosition = $("#backgroundPosition").val();
      
    	cur_settings_obj.cov_start_pos = $("#cov_start_pos").val();
    	cur_settings_obj.cov_topology = $("#cov_topology").val();
    	cur_settings_obj.cov_x_rot = parseInt($("#cov_x_rot").val());
    	cur_settings_obj.cov_y_rot = parseInt($("#cov_y_rot").val());
    	cur_settings_obj.nr_side_thumbs = parseInt($("#nr_side_thumbs").val());
    	cur_settings_obj.infinite_loop = $("#infinite_loop").val();
    	cur_settings_obj.cov_autoplay = $("#cov_autoplay").val();
    	cur_settings_obj.cov_slideshow_delay = parseInt($("#cov_slideshow_delay").val());
    	cur_settings_obj.right_click_context_menu = $("#right_click_context_menu").val();
    	cur_settings_obj.cov_keyboard_support = $("#cov_keyboard_support").val();
		  cur_settings_obj.fluid_width_z_index = parseInt($("#fluid_width_z_index").val());

    	// thumbs settings
    	cur_settings_obj.thumb_x_offset_3d = parseInt($("#thumb_x_offset_3d").val());
		  cur_settings_obj.useDefaultThumbnailsWidthAndHeight = $("#useDefaultThumbnailsWidthAndHeight").val();
		  cur_settings_obj.thumbnailWidth = parseInt($("#thumbnailWidth").val());
		  cur_settings_obj.thumbnailHeight = parseInt($("#thumbnailHeight").val());
      cur_settings_obj.thumbnailMaxHeight = parseInt($("#thumbnailMaxHeight").val());
      cur_settings_obj.thumbnailResizeOffest = parseInt($("#thumbnailResizeOffest").val());
		
    	cur_settings_obj.thumb_x_space_3d = parseInt($("#thumb_x_space_3d").val());
    	cur_settings_obj.thumb_z_offset_3d = parseInt($("#thumb_z_offset_3d").val());
    	cur_settings_obj.thumb_z_space_3d = parseInt($("#thumb_z_space_3d").val());
    	cur_settings_obj.thumb_y_angle_3d = parseInt($("#thumb_y_angle_3d").val());
    	cur_settings_obj.thumb_hover_offset = parseInt($("#thumb_hover_offset").val());
    	cur_settings_obj.thumb_border_size = parseInt($("#thumb_border_size").val());
      cur_settings_obj.thumbnailOffsetY = $("#thumbnailOffsetY").val();	
      cur_settings_obj.slideshowPreloaderBackgroundColor = $("#slideshowPreloaderBackgroundColor").spectrum("get") ? $("#slideshowPreloaderBackgroundColor").spectrum("get").toHexString() : "transparent";
      cur_settings_obj.slideshowpreloaderFillColor = $("#slideshowpreloaderFillColor").spectrum("get") ? $("#slideshowpreloaderFillColor").spectrum("get").toHexString() : "transparent";
      cur_settings_obj.preloaderBackgroundColor = $("#preloaderBackgroundColor").spectrum("get") ? $("#preloaderBackgroundColor").spectrum("get").toHexString() : "transparent";
      cur_settings_obj.preloaderFillColor = $("#preloaderFillColor").spectrum("get") ? $("#preloaderFillColor").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.thumb_bg_color = $("#thumb_bg_color").spectrum("get") ? $("#thumb_bg_color").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.thumb_border_color1 = $("#thumb_border_color1").spectrum("get") ? $("#thumb_border_color1").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.thumb_border_color2 = $("#thumb_border_color2").spectrum("get") ? $("#thumb_border_color2").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.transparent_images = $("#transparent_images").val();
    	cur_settings_obj.thumbs_alignment = $("#thumbs_alignment").val();
    	cur_settings_obj.max_thumbs_mobile = parseInt($("#max_thumbs_mobile").val());
    	cur_settings_obj.show_thumbs_gradient = $("#show_thumbs_gradient").val();
    	cur_settings_obj.thumb_gradient_color1 = $("#thumb_gradient_color1").spectrum("get") ? $("#thumb_gradient_color1").spectrum("get").toRgbString() : "transparent";
    	cur_settings_obj.thumb_gradient_color2 = $("#thumb_gradient_color2").spectrum("get") ? $("#thumb_gradient_color2").spectrum("get").toRgbString() : "transparent";
    	cur_settings_obj.show_thumbs_text = $("#show_thumbs_text").val();
    	cur_settings_obj.text_offset = parseInt($("#text_offset").val());
      cur_settings_obj.textMaxWidth = parseInt($("#textMaxWidth").val());     
    	cur_settings_obj.show_thumb_box_shadow = $("#show_thumb_box_shadow").val();
    	cur_settings_obj.box_shadow_css = $("#box_shadow_css").val().replace(/"/g, "'");
    	cur_settings_obj.show_reflection = $("#show_reflection").val();
    	cur_settings_obj.reflection_height = parseInt($("#reflection_height").val());
    	cur_settings_obj.reflection_distance = parseInt($("#reflection_distance").val());
    	cur_settings_obj.reflection_opacity = parseFloat($("#reflection_opacity").val());
		  cur_settings_obj.use_drag_and_swipe = $("#use_drag_and_swipe").val();

    	// controls settings
    	cur_settings_obj.controls_max_width = parseInt($("#controls_max_width").val());
    	cur_settings_obj.controls_position = $("#controls_position").val();
    	cur_settings_obj.controls_offset = parseInt($("#controls_offset").val());
    	cur_settings_obj.show_next_and_prev_coverflow_buttons = $("#show_next_and_prev_coverflow_buttons").val();
  		cur_settings_obj.large_next_and_prev_buttons_offest = parseInt($("#large_next_and_prev_buttons_offest").val());
      cur_settings_obj.largeNextAndPrevButtonsMaxWidthPos = parseInt($("#largeNextAndPrevButtonsMaxWidthPos").val());  
      cur_settings_obj.nextAndPrevCoverflowButtonsOffsetX = parseInt($("#nextAndPrevCoverflowButtonsOffsetX").val());    
  		cur_settings_obj.bullets_normal_radius = parseInt($("#bullets_normal_radius").val());
  		cur_settings_obj.bullets_selected_radius = parseInt($("#bullets_selected_radius").val());
  		cur_settings_obj.space_between_bullets = parseInt($("#space_between_bullets").val());
  		cur_settings_obj.bullets_offset = parseInt($("#bullets_offset").val());
		
		
		  cur_settings_obj.show_large_next_and_prev_coverflow_buttons = $("#show_large_next_and_prev_coverflow_buttons").val();
    	cur_settings_obj.disable_btns_mobile = $("#disable_btns_mobile").val();
    	cur_settings_obj.show_slideshow_btn = $("#show_slideshow_btn").val();
		  cur_settings_obj.show_bullets_navigation = $("#show_bullets_navigation").val();
    	cur_settings_obj.show_scrollbar = $("#show_scrollbar").val();
    	cur_settings_obj.scrollbar_handler_width = parseInt($("#scrollbar_handler_width").val());
    	cur_settings_obj.disable_scrollbar_mobile = $("#disable_scrollbar_mobile").val();
    	cur_settings_obj.enable_mouse_wheel = $("#enable_mouse_wheel").val();	
		  cur_settings_obj.scrollbar_text_normal_color = $("#scrollbar_text_normal_color").spectrum("get") ? $("#scrollbar_text_normal_color").spectrum("get").toRgbString() : "transparent";
    	cur_settings_obj.scrollbar_text_selected_color = $("#scrollbar_text_selected_color").spectrum("get") ? $("#scrollbar_text_selected_color").spectrum("get").toRgbString() : "transparent";
		  cur_settings_obj.bullets_normal_color = $("#bullets_normal_color").spectrum("get") ? $("#bullets_normal_color").spectrum("get").toRgbString() : "transparent";
    	cur_settings_obj.bullets_selected_color = $("#bullets_selected_color").spectrum("get") ? $("#bullets_selected_color").spectrum("get").toRgbString() : "transparent";

    	// categories menu settings
    	cur_settings_obj.show_categories_menu = $("#show_categories_menu").val();
    	cur_settings_obj.start_category = parseInt($("#start_category").val());
    	cur_settings_obj.categories_menu_max_width = parseInt($("#categories_menu_max_width").val());
    	cur_settings_obj.categories_menu_offset = parseInt($("#categories_menu_offset").val());
    	cur_settings_obj.category_normal_color = $("#category_normal_color").spectrum("get") ? $("#category_normal_color").spectrum("get").toHexString() : "transparent";
    	cur_settings_obj.category_selected_color = $("#category_selected_color").spectrum("get") ? $("#category_selected_color").spectrum("get").toHexString() : "transparent";

    	// lightbox settings
    	cur_settings_obj.buttons_alignment = $("#buttons_alignment").val();
  		cur_settings_obj.item_box_shadow = $("#item_box_shadow").val();
  		cur_settings_obj.description_windowAnimation_type = $("#description_windowAnimation_type").val();
  		cur_settings_obj.description_window_position = $("#description_window_position").val();
  		cur_settings_obj.description_window_animation_type = $("#description_window_animation_type").val();
  		cur_settings_obj.slide_show_auto_play = $("#slide_show_auto_play").val();
  		cur_settings_obj.add_keyboard_support = $("#add_keyboard_support").val();
  		cur_settings_obj.show_close_button = $("#show_close_button").val();
  		cur_settings_obj.show_share_button = $("#show_share_button").val();
  		cur_settings_obj.show_zoom_button = $("#show_zoom_button").val();
  		cur_settings_obj.show_slide_show_button = $("#show_slide_show_button").val();
  		cur_settings_obj.show_slide_show_animation = $("#show_slide_show_animation").val();
  		cur_settings_obj.show_next_and_prev_buttons = $("#show_next_and_prev_buttons").val();
  		cur_settings_obj.show_next_and_prev_buttons_on_mobile = $("#show_next_and_prev_buttons_on_mobile").val();
  		cur_settings_obj.show_description_button = $("#show_description_button").val();
  		cur_settings_obj.show_description_by_default = $("#show_description_by_default").val();
  		cur_settings_obj.video_show_full_screen_button = $("#video_show_full_screen_button").val();
  		cur_settings_obj.video_auto_play = $("#video_auto_play").val();
  		cur_settings_obj.next_video_or_audio_auto_play = $("#next_video_or_audio_auto_play").val();
  		cur_settings_obj.video_loop = $("#video_loop").val();
  		cur_settings_obj.audio_auto_play = $("#audio_auto_play").val();
  		cur_settings_obj.audio_loop = $("#audio_loop").val();
  		cur_settings_obj.background_opacity = parseFloat($("#background_opacity").val());
  		cur_settings_obj.description_window_background_opacity = parseFloat($("#description_window_background_opacity").val());
  		cur_settings_obj.buttons_hide_delay = parseInt($("#buttons_hide_delay").val());
  		cur_settings_obj.slide_show_delay = parseInt($("#slide_show_delay").val());	
  		cur_settings_obj.default_item_width = parseInt($("#default_item_width").val());	
  		cur_settings_obj.default_item_height = parseInt($("#default_item_height").val());	
  		cur_settings_obj.item_offset_height = parseInt($("#item_offset_height").val());	
  		cur_settings_obj.space_between_buttons = parseInt($("#space_between_buttons").val());	
  		cur_settings_obj.buttons_offset_in = parseInt($("#buttons_offset_in").val());	
  		cur_settings_obj.buttons_offset_out = parseInt($("#buttons_offset_out").val());	
  		cur_settings_obj.item_border_size = parseInt($("#item_border_size").val());	
  		cur_settings_obj.item_border_radius = parseInt($("#item_border_radius").val());	
      cur_settings_obj.descriptionGradientWindowBackgroundColor1 = $("#descriptionGradientWindowBackgroundColor1").spectrum("get") ? $("#descriptionGradientWindowBackgroundColor1").spectrum("get").toRgbString() : "transparent";
      cur_settings_obj.descriptionGradientWindowBackgroundColor2 = $("#descriptionGradientWindowBackgroundColor2").spectrum("get") ? $("#descriptionGradientWindowBackgroundColor2").spectrum("get").toRgbString() : "transparent";
  		cur_settings_obj.light_box_background_color = $("#light_box_background_color").spectrum("get") ? $("#light_box_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.video_poster_background_color = $("#video_poster_background_color").spectrum("get") ? $("#video_poster_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.video_controller_background_color = $("#video_controller_background_color").spectrum("get") ? $("#video_controller_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.audio_controller_background_color = $("#audio_controller_background_color").spectrum("get") ? $("#audio_controller_background_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.time_color = $("#time_color").spectrum("get") ? $("#time_color").spectrum("get").toHexString() : "transparent";
  		cur_settings_obj.item_background_color = $("#item_background_color").spectrum("get") ? $("#item_background_color").spectrum("get").toHexString() : "transparent";

    }
    
    function checkLength(el, prop, min, max)
	{
      	if ((el.val().length > max) || (el.val().length < min))
	    {
        	el.addClass("ui-state-error");
        	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
        	
        	return false;
      	}
	    else
		{
        	return true;
      	}
	}
    
    function checkIfIntegerAndLength(el, prop, min, max){
    	var int_reg_exp = /-?[0-9]+/;
    	var str = el.val();
    	var res = str.match(int_reg_exp);
    	
    	if (res && (res[0] == str))
        {
    		if ((el.val().length > max) || (el.val().length < min))
    	    {
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          	}
    	    else
    		{
            	return true;
          	}
        }
        else
        {
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be an integer.");
        	
        	return false;
        }
	}
    
    function checkIfFloatAndLength(el, prop, min, max)
	{
    	var float_reg_exp = /1\.0|0?\.[0-9]+|[01]/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);
    	
    	if (res && (res[0] == str))
        {
    		if ((el.val().length > max) || (el.val().length < min))
    	    {
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	
            	return false;
          	}
    	    else
    		{
            	return true;
          	}
        }
        else
        {
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");
        	
        	return false;
        }
	}
	
	
	
	function checkIfFloatAndLength2(el, prop, min, max){
    	var float_reg_exp = /[0-9]*\.?[0-9]+/;
    	var str = el.val();
    	var res = str.match(float_reg_exp);

    	if (res && (res[0] == str)){
    		if ((el.val().length > max) || (el.val().length < min)){
            	el.addClass("ui-state-error");
            	updateTips("Length of " + prop + " must be between " + min + " and " + max + ".");
            	return false;
          	}else{
            	return true;
          	}
        }else{
        	el.addClass("ui-state-error");
        	updateTips("The " + prop + " field value must be a float number.");
        	return false;
        }
	}
	
	

	function updateTips(txt)
	{
		$("#tips").text(txt).addClass("ui-state-highlight");

	    setTimeout(function()
		{
	    	$("#tips").removeClass("ui-state-highlight", 1500);
	    }, 500);
	    
	    $("#tips").addClass("fwd-error");
	}
	

	var allFields = $([]).add($("#name")).add($("#cov_width")).add($("#coverflowOffsetHeight")).add($("#skin_path")).add($("#cov_bg_image_url")).add($("#cov_x_rot")).add($("#cov_y_rot"))
	 					  .add($("#cov_slideshow_delay")) .add($("#fluid_width_z_index")).add($("#thumbnailWidth")).add($("#thumbnailHeight")).add($("#thumbnailMaxHeight")).add($("#thumbnailResizeOffest")).add($("#thumb_x_offset_3d")).add($("#thumb_x_space_3d")).add($("#thumb_z_offset_3d")).add($("#thumb_z_space_3d")).add($("#thumb_y_angle_3d")).add($("#thumb_hover_offset")).add($("#thumb_border_size")).add($("#max_thumbs_mobile")).add($("#text_offset")).add($("#textMaxWidth")).add($("#box_shadow_css")).add($("#reflection_height")).add($("#reflection_distance")).add($("#reflection_opacity")).add($("#controls_max_width")).add($("#controls_offset")).add($("#scrollbar_handler_width")).add($("#nextAndPrevCoverflowButtonsOffsetX")).add($("#start_category")).add($("#categories_menu_max_width"))
	 					  .add($("#categories_menu_offset")).add($("#background_opacity")).add($("#description_window_background_opacity")).add($("#buttons_hide_delay")).add($("#slide_show_delay")).add($("#default_item_width")).add($("#item_offset_height")).add($("#space_between_buttons")).add($("#buttons_offset_in")).add($("#buttons_offset_out")).add($("#item_border_size")).add($("#item_border_radius")).add($("#thumbnail_max_width")).add($("#thumbnail_max_height"));
	 					  
	var fValid = false;
	
	

	function validateFields()
	{
		fValid = true;
     	
      	allFields.removeClass("ui-state-error");

      	// main settings
      	fValid = fValid && checkLength($("#name"), "name", 1, 64);
      	fValid = fValid && checkIfIntegerAndLength($("#cov_width"), "coverflow width", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#coverflowOffsetHeight"), "coverflow offset height", 1, 8);
      	fValid = fValid && checkLength($("#skin_path"), "skin path", 1, 256);
      	fValid = fValid && checkLength($("#cov_bg_image_url"), "background image path", 0, 256);
    	  fValid = fValid && checkIfIntegerAndLength($("#cov_x_rot"), "coverflow X rotation", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#cov_y_rot"), "coverflow Y rotation", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#cov_slideshow_delay"), "coverflow slideshow delay", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#fluid_width_z_index"), "fluid-width z-index", 1, 16);
      	
      	if (!fValid)
      	{
      		$("#tabs").tabs("option", "active", 0);
      		
      		window.scrollTo(0,0);
      		
      		return false;
      	}
		
      	
      	// thumbs settings
		    fValid = fValid && checkIfIntegerAndLength($("#thumbnailWidth"), "thumbnail width", 1, 8);
		    fValid = fValid && checkIfIntegerAndLength($("#thumbnailHeight"), "thumbnail height", 1, 8);
        fValid = fValid && checkIfIntegerAndLength($("#thumbnailMaxHeight"), "thumbnail max height", 1, 8);
        fValid = fValid && checkIfIntegerAndLength($("#thumbnailResizeOffest"), "thumbnail resize offset", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_x_offset_3d"), "thumbnail X offset 3D", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_x_space_3d"), "thumbnail X space 3D", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_z_offset_3d"), "thumbnail Z offset 3D", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_z_space_3d"), "thumbnail Z space 3D", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_y_angle_3d"), "thumbnail Y angle 3D", 1, 8);
    	  fValid = fValid && checkIfIntegerAndLength($("#thumb_hover_offset"), "thumbnail hover offset", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#thumb_border_size"), "thumbnail border size", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#max_thumbs_mobile"), "maximum number of thumbnails on mobiles", 1, 8);
        fValid = fValid && checkIfIntegerAndLength($("#textMaxWidth"), "thumbnail text max width", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#text_offset"), "thumbnail text offset", 1, 8);
      	fValid = fValid && checkLength($("#box_shadow_css"), "thumbnail box shadow CSS", 1, 64);
      	fValid = fValid && checkIfIntegerAndLength($("#reflection_height"), "thumbnail reflection height", 1, 8);
    	  fValid = fValid && checkIfIntegerAndLength($("#reflection_distance"), "thumbnail reflection distance", 1, 8);
    	  fValid = fValid && checkIfFloatAndLength($("#reflection_opacity"), "thumbnail reflection opacity", 1, 8);
      	
      	if (!fValid)
      	{
      		$("#tabs").tabs("option", "active", 1);
      		
      		window.scrollTo(0,0);
      		
      		return false;
      	}
      	
      	// controls settings
      	fValid = fValid && checkIfIntegerAndLength($("#controls_max_width"), "controls maximum width", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#controls_offset"), "controls offset", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#scrollbar_handler_width"), "scrollbar handler width", 1, 8);
    		fValid = fValid && checkIfIntegerAndLength($("#large_next_and_prev_buttons_offest"), "large next and prev buttons offset", 1, 8);
        fValid = fValid && checkIfIntegerAndLength($("#largeNextAndPrevButtonsMaxWidthPos"), "large next and prev buttons max width position", 1, 8);
        fValid = fValid && checkIfIntegerAndLength($("#nextAndPrevCoverflowButtonsOffsetX"), "large next and prev buttons offset x", 1, 8);
    		fValid = fValid && checkIfIntegerAndLength($("#bullets_normal_radius"), "navigation bullets normal radius", 1, 8);
    		fValid = fValid && checkIfIntegerAndLength($("#bullets_selected_radius"), "navigation bullets selected radius", 1, 8);
    		fValid = fValid && checkIfIntegerAndLength($("#space_between_bullets"), "space between bullets navigation", 1, 8);
    		fValid = fValid && checkIfIntegerAndLength($("#bullets_offset"), "bullets navigation offset Y", 1, 8);
		
      	if (!fValid)
      	{
      		$("#tabs").tabs("option", "active", 2);
      		
      		window.scrollTo(0,0);
      		
      		return false;
      	}
      	
      	// categories menu settings
      	fValid = fValid && checkIfIntegerAndLength($("#start_category"), "combobox start category", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#categories_menu_max_width"), "categories menu maximum width", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#categories_menu_offset"), "categories menu offset", 1, 8);
      	
      	if (!fValid)
      	{
      		$("#tabs").tabs("option", "active", 3);
      		
      		window.scrollTo(0,0);
      		
      		return false;
      	}
      	
      	// lightbox settings
      	fValid = fValid && checkIfFloatAndLength2($("#background_opacity"), "main background opacity", 1, 8);
		fValid = fValid && checkIfFloatAndLength2($("#description_window_background_opacity"), "description window background opacity:", 1, 8);
      	fValid = fValid && checkIfIntegerAndLength($("#buttons_hide_delay"), "buttons hide delay", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#slide_show_delay"), "slideshow hide delay", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#default_item_width"), "default item width", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#default_item_height"), "default item height", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#item_offset_height"), "item offset height", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#space_between_buttons"), "space between buttons", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#buttons_offset_in"), "buttons offset in", 1, 8);	
		fValid = fValid && checkIfIntegerAndLength($("#buttons_offset_out"), "buttons offset out", 1, 8);			
		fValid = fValid && checkIfIntegerAndLength($("#item_border_size"), "item border size", 1, 8);
		fValid = fValid && checkIfIntegerAndLength($("#item_border_radius"), "item border radius", 1, 8);
      	
      	if (!fValid)
      	{
      		$("#tabs").tabs("option", "active", 4);
      		
      		window.scrollTo(0,0);
      		
      		return false;
      	}
	}
    
    $("#add_btn").click(function(e)
	{
		
		if($("#name").val() == settingsAr[cur_order_id]["name"]){
			updateTips("Please make sure that the preset name is unique");
			$("#name").addClass("ui-state-error");
			$("#tabs").tabs("option", "active", 0);
			window.scrollTo(0,0);
			return false;
		};
		
    	validateFields();

      	if (fValid)
        {
      		cur_settings_obj = {};
        	
        	sid = $("#skins option").length;
        	cur_order_id = $("#skins option").length;
        	
      		var idsAr = [];
      		
      		if (sid > DEFAULT_SKINS_NR)
      		{
      			$.each(settingsAr, function(i, el)
    			{
    				idsAr.push(el.id);
    			});
          		
          		for (var i=DEFAULT_SKINS_NR; i<settingsAr.length; i++)
          		{
          			if ($.inArray(i, idsAr) == -1)
          			{
          				sid = i;
          				break;
          			}
          		}
      		}
        	
			
	    	updateSettings();
	    	settingsAr.push(cur_settings_obj);
	    	
	    	var data_obj =
	    	{
	    		action: "add",
	    		set_id: sid,
	    		set_order_id: cur_order_id,
	    		tab_init_id: $("#tabs").tabs("option", "active"),
	    		settings_ar: settingsAr
	    	};
	    	
	    	$("#settings_data").val(JSON.stringify(data_obj));
			
        }
      	else
      	{
      		return false;
      	}
    });
    
    $("#update_btn").click(function()
	{
    	validateFields();

      	if (fValid)
        {
      		cur_settings_obj = {};
      		
	    	updateSettings();
	    	
	    	settingsAr[cur_order_id] = cur_settings_obj;
	    	
	    	var data_obj =
	    	{
	    		action: "save",
	    		set_id: sid,
	    		set_order_id: cur_order_id,
	    		tab_init_id: $("#tabs").tabs("option", "active"),
	    		settings_ar: settingsAr
	    	};
	    	
	    	$("#settings_data").val(JSON.stringify(data_obj));
        }
      	else
      	{
      		return false;
      	}
    });
    
    $("#del_btn").click(function()
	{
    	settingsAr.splice(cur_order_id, 1);
    	
    	var data_obj =
    	{
    		action: "del",
    		settings_ar: settingsAr
    	};
    	
    	$("#settings_data").val(JSON.stringify(data_obj));
    });
});